
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileEfigramDecoderAttributes.h
    \brief Definition of EfigramDecoder Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/
   

#ifndef EfigramDecoderAttributes_H
#define EfigramDecoderAttributes_H

#include "magics.h"
#include "Colour.h"
namespace magics {

class XmlNode;
class EfigramDecoderAttributes 
{
public:
//  --  constructor
    EfigramDecoderAttributes();
    
//  --  destructor
    virtual ~EfigramDecoderAttributes();
    
    virtual void set(const std::map<std::string, std::string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const EfigramDecoderAttributes&);
    virtual bool accept(const std::string&);

    void setTag(const std::string& tag) { tag_ = tag; }

public:
	//  --  method
	virtual void print(std::ostream&) const;
	virtual void toxml(std::ostream& out) const;
	//  --  members:
	string tag_;
	string database_;
	string legend_database_;
	string clim_database_;
	stringarray dates_;
	string clim_param_;
	string clim_date_;
	int clim_step_;
	intarray steps_;
	string param_;
	bool long_title_;
	bool title_;
	double latitude_;
	double longitude_;
	bool legend_;
	stringarray legend_colours_;
	string legend_type_;
	int legend_normal_thickness_;
	unique_ptr<Colour> legend_normal_colour_;
	 

private:
	friend ostream& operator<<(ostream& s,const EfigramDecoderAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif

