
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileKMLDriverAttributes.h
    \brief Definition of KMLDriver Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/
   

#ifndef KMLDriverAttributes_H
#define KMLDriverAttributes_H

#include "magics.h"
namespace magics {

class XmlNode;
class KMLDriverAttributes 
{
public:
//  --  constructor
    KMLDriverAttributes();
    
//  --  destructor
    virtual ~KMLDriverAttributes();
    
    virtual void set(const std::map<std::string, std::string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const KMLDriverAttributes&);
    virtual bool accept(const std::string&);

    void setTag(const std::string& tag) { tag_ = tag; }

public:
	//  --  method
	virtual void print(std::ostream&) const;
	virtual void toxml(std::ostream& out) const;
	//  --  members:
	string tag_;
	bool kmz_;
	string description_;
	string author_;
	string link_;
	double height_;
	double latitude_;
	double longitude_;
	int transparency_;
	int tilt_;
	int range_;
	bool coastlines_;
	 

private:
	friend ostream& operator<<(ostream& s,const KMLDriverAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif

